unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LR_Class, LR_View, LR_Desgn, LR_DSet, Forms,
  Controls, Graphics, Dialogs, ComCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    frDesigner1: TfrDesigner;
    frPreview1: TfrPreview;
    frUserDataset1: TfrUserDataset;
    Report: TfrReport;
    ListView1: TListView;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure frUserDataset1CheckEOF(Sender: TObject; var Eof: Boolean);
    procedure frUserDataset1First(Sender: TObject);
    procedure frUserDataset1Next(Sender: TObject);
    procedure ReportGetValue(const ParName: String; var ParValue: Variant);
  private
    FRow: Integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Report.DesignReport;
  Report.ShowReport;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  ReportFile: String;
begin
  ReportFile := GetCurrentDir + PathDelim + 'test.lrf';
  if FileExists(ReportFile) then
    Report.LoadFromFile(ReportFile);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Report.ShowReport;
end;

procedure TForm1.frUserDataset1CheckEOF(Sender: TObject; var Eof: Boolean);
begin
  Eof := FRow = ListView1.Items.Count;
end;

procedure TForm1.frUserDataset1First(Sender: TObject);
begin
  FRow := 0;
end;

procedure TForm1.frUserDataset1Next(Sender: TObject);
begin
  Inc(FRow);
end;

procedure TForm1.ReportGetValue(const ParName: String; var ParValue: Variant);
var
  ListItem: TListItem;
  i: Integer;
begin
  case ParName of
    'Item0':
    begin
      ListItem := ListView1.Items[FRow];
      ParValue := ListItem.Caption;
      for i := 0 to ListItem.SubItems.Count - 1 do
        ParValue := ParValue + ' ' + ListItem.SubItems[i];
    end;
  end;
end;

end.

